VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} TriangForm 
   Caption         =   "TriangForm"
   ClientHeight    =   2970
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6180
   OleObjectBlob   =   "TriangForm.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "TriangForm"
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private TheArray As New TriangularArray
Private A(0 To 4, 0 To 4) As Label
Private B(0 To 9) As Label

' Save the entry's value.
Private Sub CmdSet_Click()
Dim Row As Integer
Dim Col As Integer
Dim txt As String
Dim X As Integer

    Row = CInt(RowText.Text)
    Col = CInt(ColText.Text)
    If Col < 0 Or Col > 4 Or _
       Row < 0 Or Row > 4 Or Row = Col _
    Then
        MsgBox "Invalid row or column."
        Exit Sub
    End If
    
    txt = ValueText.Text
    TheArray.Value(Row, Col) = txt
    
    ' Update the array displays.
    A(Row, Col) = txt
    X = Row * (Row - 1) \ 2 + Col
    B(X) = txt
End Sub
' Retrieve the entry's value.
Private Sub CmdGet_Click()
Dim Row As Integer
Dim Col As Integer

    Row = CInt(RowText.Text)
    Col = CInt(ColText.Text)
    If Col < 0 Or Col > 4 Or _
       Row < 0 Or Row > 4 Or Row = Col _
    Then
        MsgBox "Invalid row or column."
        Exit Sub
    End If
    
    ValueText.Text = TheArray.Value(Row, Col)
End Sub

Private Sub UserForm_Layout()
Dim Row As Integer
Dim Col As Integer
Dim X As Integer

    ' Initialize the triangular array.
    TheArray.Initialize 5
    For Row = 1 To 4
        For Col = 0 To Row - 1
            TheArray.Value(Row, Col) = _
                "A(" & _
                Format$(Row) & ", " & _
                Format$(Col) & ")"
        Next Col
    Next Row
    
    ' Save the array labels.
    Set A(1, 0) = A10
    Set A(2, 0) = A20
    Set A(2, 1) = A21
    Set A(3, 0) = A30
    Set A(3, 1) = A31
    Set A(3, 2) = A32
    Set A(4, 0) = A40
    Set A(4, 1) = A41
    Set A(4, 2) = A42
    Set A(4, 3) = A43

    Set B(0) = B0
    Set B(1) = B1
    Set B(2) = B2
    Set B(3) = B3
    Set B(4) = B4
    Set B(5) = B5
    Set B(6) = B6
    Set B(7) = B7
    Set B(8) = B8
    Set B(9) = B9

    ' Display the values.
    For Row = 1 To 4
        For Col = 0 To Row - 1
            A(Row, Col).Caption = TheArray.Value(Row, Col)
            X = Row * (Row - 1) \ 2 + Col
            B(X).Caption = TheArray.Value(Row, Col)
        Next Col
    Next Row
End Sub
