VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TriangularArray"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private B() As String
Private NumRows As Integer
Private MaxItem As Integer

' Initialize the one-dimensional array B.
Public Sub Initialize(ByVal rows As Integer)
    NumRows = rows
    MaxItem = (rows - 1) * (rows - 2) \ 2 + (rows - 2)
    ReDim B(0 To MaxItem)
End Sub
' Get the value for Array(row, col).
Public Property Get Value(ByVal Row As Integer, ByVal Col As Integer) As String
Dim X As Integer

    ' If col > row, swap them.
    If Col > Row Then
        X = Row
        Row = Col
        Col = X
    End If
    
    X = Row * (Row - 1) \ 2 + Col
    Value = B(X)
End Property
' Set the value for Array(row, col).
Public Property Let Value(ByVal Row As Integer, ByVal Col As Integer, ByVal new_value As String)
Dim X As Integer

    ' If col > row, swap them.
    If Col > Row Then
        X = Row
        Row = Col
        Col = X
    End If
    
    X = Row * (Row - 1) \ 2 + Col
    B(X) = new_value
End Property
